import { jsx as a, jsxs as q } from "react/jsx-runtime";
import { useCallback as E, useState as H, useEffect as K } from "react";
import { useLocation as ke } from "react-router-dom";
import { T as C, x as $e, y as we, z as Se, B as Ee, C as Ve, E as Y, G as ze, H as Oe, I as Le, u as _e, A as He, a as Ue, b as Ae, c as Fe, J as je, U as qe, N as We, m as Ge } from "./index-Bx-K1R4c.js";
import { makeStyles as ee, lighten as Z, darken as De, useTheme as Re, Tooltip as Je, CircularProgress as Pe, Typography as X } from "@material-ui/core";
import Ke from "@material-ui/lab/TreeView";
import Xe from "@material-ui/lab/TreeItem";
import Q from "clsx";
import { useDrag as Ye, useDrop as Qe, DndProvider as Ze } from "react-dnd";
import { CaretUpSolid8Icon as ei, CaretDownSolid8Icon as ii } from "@fluentui/react-icons";
import { cloneDeep as ni } from "lodash";
import { HTML5Backend as ri } from "react-dnd-html5-backend";
const oi = ee((i) => {
  var l, d;
  return {
    root: {
      "&.Mui-selected > .MuiTreeItem-content": {
        backgroundColor: ((l = i == null ? void 0 : i.getThemeData()) == null ? void 0 : l.mode) === "dark" ? i.palette.grey[700] : i.palette.grey[300],
        borderRight: `4px solid ${i.palette.primary.main}`
      },
      "&.Mui-selected > .MuiTreeItem-content .MuiTreeItem-label": {
        backgroundColor: "transparent",
        paddingLeft: 0
      },
      "&.Mui-selected > .MuiTreeItem-content > .MuiCollapse-wrapperInner": {
        backgroundColor: ((d = i == null ? void 0 : i.getThemeData()) == null ? void 0 : d.mode) !== "dark" && i.palette.grey[50]
      },
      "& .MuiTreeItem-content .MuiTreeItem-iconContainer": {
        display: (n) => n.sidebarExpanded ? "flex" : "none"
      }
    },
    content: {
      backgroundColor: (n) => {
        var f;
        return ((f = i == null ? void 0 : i.getThemeData()) == null ? void 0 : f.mode) !== "dark" && n.conditionalIconName && n.conditionalIconColor ? Z(n.conditionalIconColor, 0.92) : "";
      }
    },
    labelRoot: {
      display: "flex",
      alignItems: "center",
      marginLeft: (n) => n.sidebarExpanded ? 0 : i.spacing(1.5),
      width: "100%"
    },
    labelContainer: {
      display: (n) => n.sidebarExpanded ? "" : "none",
      width: (n) => n.treeViewMode === C.Compact ? `calc(100% - ${i.spacing(6.25)}px)` : `calc(100% - ${i.spacing(7.75)}px)`
    },
    conditionalIconContainer: {
      display: "inline-flex"
    },
    labelText: {
      fontSize: "0.75rem",
      fontWeight: 600,
      lineHeight: "1rem",
      letterSpacing: 0.1
    },
    captionText: {
      marginLeft: (n) => n.treeViewMode === C.Compact ? i.spacing(1) : "",
      fontSize: "0.65rem",
      fontWeight: 400,
      lineHeight: 1,
      letterSpacing: 0.4
    },
    labelOverflow: {
      whiteSpace: "nowrap",
      overflow: "hidden",
      textOverflow: "ellipsis"
    },
    group: {
      width: "100%",
      "& .MuiTreeItem-group": {
        marginLeft: 0
      },
      "& .MuiTreeItem-content": {
        paddingLeft: (n) => n.sidebarExpanded ? (n.depth || 1) * i.spacing(1) : 0,
        borderRight: (n) => n.showRightBorderColor ? `4px solid ${i.palette.primary.main}` : "",
        borderBottom: (n) => n.treeViewMode === C.Compact ? `1px solid ${i.palette.grey[200]}` : ""
      },
      "& .MuiTreeItem-content .MuiTreeItem-label": {
        paddingLeft: 0,
        width: (n) => n.sidebarExpanded && `calc(100% - ${i.spacing(2.5)}px)`
      },
      "& .MuiTreeItem-content .MuiTreeItem-iconContainer span": {
        display: (n) => n.hideExpansion ? "none" : ""
      },
      "& .MuiCollapse-wrapperInner": {
        backgroundColor: (n) => {
          var f;
          return ((f = i == null ? void 0 : i.getThemeData()) == null ? void 0 : f.mode) !== "dark" && n.isSelectedNode ? i.palette.grey[50] : "";
        }
      }
    },
    iconContainer: {
      display: "flex",
      alignItems: "center",
      justifyContent: "center",
      borderRadius: 50,
      marginTop: (n) => n.treeViewMode === C.Compact ? i.spacing(0.25) : i.spacing(0.5),
      marginBottom: (n) => n.treeViewMode === C.Compact ? i.spacing(0.25) : i.spacing(0.5),
      marginRight: i.spacing(1),
      width: (n) => n.treeViewMode === C.Compact ? i.spacing(3) : i.spacing(4),
      height: (n) => n.treeViewMode === C.Compact ? i.spacing(3) : i.spacing(4),
      border: (n) => n.iconColor ? `1px solid ${De(n.iconColor, 0.1)}` : `1px solid ${i.palette.secondary.main}`,
      backgroundColor: "#ffffff"
    }
  };
}), ai = (i) => {
  var D;
  const {
    parentId: l,
    nodeId: d,
    iconName: n,
    iconType: f,
    conditionalIconName: I,
    conditionalIconType: T,
    conditionalIconColor: r,
    label: N,
    iconColor: p,
    onNodeSelect: L,
    isSelectedNode: B,
    subLabel: u,
    sidebarExpanded: A,
    isLastNode: U,
    loading: k,
    node: o,
    onDropNode: z,
    treeViewMode: m,
    menuIndex: v,
    aggregateThresholdId: F,
    ...O
  } = i, g = oi(i), $ = Re(), [{ isDragging: e }, c] = Ye({
    type: "BaseTreeMenuItem",
    item: { ...o, sourceNodeMenuIndex: v },
    collect: (t) => ({
      isDragging: t.isDragging()
    })
  }), s = E(
    (t, x) => {
      if (!x.didDrop() && z) {
        const { sourceNodeMenuIndex: w, ...S } = t;
        z({ ...S }, o, w, v);
      }
    },
    [z, o, v]
  ), [, b] = Qe(
    () => ({
      accept: ["BaseTreeMenuItem"],
      drop: (t, x) => {
        s(t, x);
      },
      canDrop: (t) => V(t),
      collect: (t) => ({
        isOver: t.isOver(),
        canDrop: !!t.canDrop()
      })
    }),
    [s]
  ), V = E(
    (t) => {
      var x, w, S;
      if (t) {
        const R = (w = (x = o == null ? void 0 : o.properties) == null ? void 0 : x.nodeActions) == null ? void 0 : w.filter(
          (y) => (y == null ? void 0 : y.triggerType) === $e.On_Node_Drop
        );
        return R ? (R == null ? void 0 : R.map(
          (y) => y == null ? void 0 : y.dragEntityName
        )).includes(
          (S = t == null ? void 0 : t.properties) == null ? void 0 : S.catalogReturnObject
        ) : !1;
      }
    },
    [o]
  ), M = E(
    (t) => {
      t.preventDefault(), L(t, d);
    },
    [L, d]
  );
  return /* @__PURE__ */ a(
    Xe,
    {
      className: g.group,
      nodeId: d,
      label: /* @__PURE__ */ a("div", { ref: b, children: /* @__PURE__ */ a(Je, { title: A ? "" : N, children: /* @__PURE__ */ a(
        "div",
        {
          ref: ((D = o == null ? void 0 : o.properties) == null ? void 0 : D.isDraggable) && c || null,
          style: { opacity: e ? 0.5 : 1 },
          children: k ? /* @__PURE__ */ a(Pe, { size: 12 }) : /* @__PURE__ */ q(
            "div",
            {
              id: "udpRecord-BaseTreeMenuItem-" + N.replace(/\s+/g, ""),
              udprecordid: "udpRecord-BaseTreeMenuItem-" + N.replace(/\s+/g, ""),
              className: g.labelRoot,
              style: {
                fontWeight: B ? "bold" : ""
              },
              children: [
                n && /* @__PURE__ */ a("div", { className: g.iconContainer, children: /* @__PURE__ */ a(
                  we,
                  {
                    size: m === C.Compact ? "small" : "medium",
                    color: p,
                    type: f,
                    icon: f === "unity" ? Se(n) : Ee(n),
                    style: {
                      color: p ? De(p, 0.1) : $.palette.secondary.main
                    }
                  }
                ) }),
                /* @__PURE__ */ q("div", { className: g.labelContainer, children: [
                  /* @__PURE__ */ q(
                    X,
                    {
                      variant: "subtitle2",
                      className: Q(g.labelText, g.labelOverflow),
                      children: [
                        N,
                        u && m === C.Compact && /* @__PURE__ */ a(
                          X,
                          {
                            variant: "caption",
                            className: Q(
                              g.captionText,
                              g.labelOverflow
                            ),
                            children: u
                          }
                        )
                      ]
                    }
                  ),
                  u && m === C.Classic && /* @__PURE__ */ a("div", { className: g.labelOverflow, children: /* @__PURE__ */ a(
                    X,
                    {
                      variant: "caption",
                      className: Q(g.captionText),
                      children: u
                    }
                  ) })
                ] }),
                /* @__PURE__ */ a(Ve, { aggregateThresholdId: F }),
                I && A && /* @__PURE__ */ a("div", { className: g.conditionalIconContainer, children: /* @__PURE__ */ a(
                  we,
                  {
                    size: m === C.Compact ? "small" : "medium",
                    color: r,
                    type: T,
                    icon: T === "unity" ? Se(I) : Ee(I),
                    style: {
                      color: r
                    }
                  }
                ) })
              ]
            }
          )
        }
      ) }) }),
      onLabelClick: M,
      classes: { root: g.root, content: g.content },
      ...O
    },
    d
  );
}, ti = ee((i) => ({
  root: {
    marginBottom: i.spacing(1.75),
    borderTop: (l) => l.treeViewMode === C.Compact ? `1px solid ${i.palette.grey[200]}` : ""
  },
  noChildrenContainer: {
    borderBottom: (l) => l.treeViewMode === C.Compact ? `1px solid ${i.palette.grey[200]}` : ""
  }
})), li = (i) => {
  const {
    menuItems: l,
    onSelectNode: d,
    onDropNode: n,
    menuIndex: f,
    selectedNodeId: I,
    selectedNodeParentId: T,
    sidebarExpanded: r,
    treeViewMode: N,
    childrenKey: p = "children"
  } = i, [L, B] = H(null), [u, A] = H(!1), [U, k] = H(!1), [o, z] = H(l), m = Re(), v = ti(i), F = E(
    (e, c) => {
      const s = Y(o, c);
      d && (d(s, f), k(!1));
    },
    [o, f, d]
  ), O = E(
    (e, c = 1) => {
      var j, y, W, G, h, P, J, _, ie, ne, re, oe, ae, te, le, se, ce, de, pe, ge, ue, me, fe, Ie, Ce, ye, he, be, Te, xe, Ne, ve, Me;
      let s = ((j = e.properties) == null ? void 0 : j.nodeLabel) || ((y = e.properties) == null ? void 0 : y.name), b = (W = e.properties) == null ? void 0 : W.nodeSubLabel, V = (h = (G = e.properties) == null ? void 0 : G.defaultIcon) == null ? void 0 : h.name, M = (J = (P = e.properties) == null ? void 0 : P.defaultIcon) == null ? void 0 : J.type, D = ((_ = e.properties) == null ? void 0 : _.conditionalIconName) || "", t = (ie = e.properties) != null && ie.conditionalIconName ? e.properties.conditionalIconType : "", x = (ne = e.properties) != null && ne.conditionalIconName ? (re = e.properties) == null ? void 0 : re.conditionalIconColor : "", w = e.id, S = (oe = e.properties) != null && oe.conditionalIconName ? (ae = e.properties) == null ? void 0 : ae.conditionalIconColor : (se = (le = (te = e.properties) == null ? void 0 : te.defaultIcon) == null ? void 0 : le.color) == null ? void 0 : se.hex, R = ((ce = e.properties) == null ? void 0 : ce.aggregateThresholdId) || "";
      return e.isGroupNode && (s = (de = e.properties) == null ? void 0 : de.label, b = (pe = e.properties) == null ? void 0 : pe.subLabel, V = (ue = (ge = e.properties) == null ? void 0 : ge.icon) == null ? void 0 : ue.name, M = (fe = (me = e.properties) == null ? void 0 : me.icon) == null ? void 0 : fe.type, S = (ye = (Ce = (Ie = e.properties) == null ? void 0 : Ie.icon) == null ? void 0 : Ce.color) == null ? void 0 : ye.hex), /* @__PURE__ */ q(
        ai,
        {
          nodeId: w,
          label: s,
          subLabel: b,
          iconName: V,
          iconType: M,
          conditionalIconName: D,
          conditionalIconType: t,
          conditionalIconColor: x,
          parentId: e.parentId,
          iconColor: S,
          onNodeSelect: F,
          selectedNodeId: I,
          isSelectedNode: I === e.id,
          showRightBorderColor: U && u && ze(L, o, T) === e.id,
          isCurrentActiveTree: u,
          sidebarExpanded: r,
          depth: c,
          hideExpansion: !((he = e[p]) != null && he.length),
          node: e,
          onDropNode: n,
          treeViewMode: N,
          menuIndex: f,
          aggregateThresholdId: R,
          children: [
            ((be = e.properties) == null ? void 0 : be.lazyLoad) && !((Te = e[p]) != null && Te.length) && !e.completedLoadingChildren && /* @__PURE__ */ a(
              Pe,
              {
                size: 12,
                style: { marginLeft: (c || 1) * m.spacing(1) }
              }
            ),
            ((xe = e.properties) == null ? void 0 : xe.lazyLoad) && !((Ne = e[p]) != null && Ne.length) && e.completedLoadingChildren && r && !e.errorRetrievingChildren && /* @__PURE__ */ a("div", { className: v.noChildrenContainer, children: /* @__PURE__ */ a(
              X,
              {
                variant: "caption",
                style: {
                  marginLeft: (c || 1) * m.spacing(3),
                  fontWeight: 400
                },
                children: "No Children"
              }
            ) }),
            ((ve = e.properties) == null ? void 0 : ve.lazyLoad) && e.completedLoadingChildren && r && e.errorRetrievingChildren && /* @__PURE__ */ a("div", { className: v.noChildrenContainer, children: /* @__PURE__ */ a(
              X,
              {
                variant: "caption",
                style: {
                  marginLeft: (c || 1) * m.spacing(3),
                  fontWeight: 400
                },
                children: `Error Retrieving ${(Me = e[p]) != null && Me.length ? "Additional " : ""}Children`
              }
            ) }),
            Array.isArray(e[p]) ? e[p].map((Be, ci) => O(Be, c + 1)) : null
          ]
        },
        w
      );
    },
    [
      F,
      I,
      U,
      u,
      r,
      L,
      o,
      T,
      m,
      v,
      n,
      N,
      f,
      p
    ]
  ), g = E(
    async (e, c) => {
      const s = ni(o);
      B(c);
      const b = Y(s, T), M = Oe(
        s,
        b,
        T ? [T] : []
      ), D = M.every(
        (t) => c.includes(t)
      );
      u && M.length && !D ? k(!0) : k(!1);
    },
    [u, o, T]
  ), $ = E(
    (e) => e ? e.reduce((c, s) => {
      var b;
      return s != null && s.isExpanded && c.push(s.id), s && ((b = s[p]) != null && b.length) && (c = c.concat(
        $(s[p])
      )), c;
    }, []) : [],
    [p]
  );
  return K(() => {
    z(l);
  }, [l]), K(() => {
    if (!o)
      return;
    let e = [];
    o != null && o.isExpanded && e.push(o.id), e = e.concat($(o[p])), B(e);
  }, [$, o, p]), K(() => {
    Y(o, I) ? A(!0) : A(!1);
  }, [o, I]), L ? /* @__PURE__ */ a(
    Ke,
    {
      className: v.root,
      defaultCollapseIcon: /* @__PURE__ */ a(
        Le,
        {
          size: "small",
          component: ei,
          style: {
            color: Z(m.palette.primary.main, 0.5),
            width: m.spacing(1.5),
            height: m.spacing(1.5)
          }
        }
      ),
      expanded: L || [],
      onNodeToggle: g,
      defaultExpandIcon: /* @__PURE__ */ a(
        Le,
        {
          size: "small",
          component: ii,
          style: {
            color: Z(m.palette.primary.main, 0.5),
            width: m.spacing(1.5),
            height: m.spacing(1.5)
          }
        }
      ),
      selected: I,
      children: o && O(o)
    },
    o
  ) : null;
}, si = ee((i) => ({
  root: {
    flex: 1,
    minHeight: ({ appRibbonSpace: l }) => `calc(100vh - ${l + 56}px)`,
    display: "grid",
    gridTemplateAreas: ["sidebar content"].map((l) => `"${l}"`).join(" "),
    gridTemplateColumns: "auto 1fr",
    gridTemplateRows: "auto 1fr"
  },
  sidebar: {
    gridArea: "sidebar",
    marginRight: i.spacing(1)
  },
  content: {
    gridArea: "content",
    display: "flex",
    flexDirection: "column",
    position: "relative",
    zIndex: 1,
    height: ({ appRibbonSpace: l }) => `calc(100vh - ${l + 56}px)`,
    overflowY: "auto"
  },
  menuContent: {
    marginTop: i.spacing(1),
    height: ({ appRibbonSpace: l }) => `calc(100vh - ${l + 116}px)`,
    overflowX: "hidden"
  },
  loader: {
    marginRight: i.spacing(1),
    marginLeft: i.spacing(1)
  },
  loadingContent: {
    flex: 1,
    display: "flex",
    flexDirection: "column",
    alignItems: "center",
    justifyContent: "center"
  }
})), xi = (i) => {
  var O, g, $, e, c, s, b, V, M, D, t, x, w, S, R, j, y, W, G;
  const l = _e(), d = si({ ...i, appRibbonSpace: l ? He : 0 }), n = ke(), f = Ue(), [I, T] = H([]), [r, N] = H(null), [p, L] = H(!0), B = n.pathname.replace("/menupage/", ""), [{ data: u, loading: A }] = Ae(
    process.env.REACT_APP_TENANTS_API_BASE,
    `menus/${B}`,
    {},
    !B,
    !1
  ), { setSubHeaderActionHasChildren: U, setNavigationExpanded: k } = Fe(), [{ data: o, loading: z }] = Ae(
    process.env.REACT_APP_TENANTS_API_BASE,
    `page/${(g = (O = r == null ? void 0 : r.properties) == null ? void 0 : O.page) == null ? void 0 : g.id}`,
    {},
    !((e = ($ = r == null ? void 0 : r.properties) == null ? void 0 : $.page) != null && e.id),
    !1
  ), m = E((h, P) => {
    N(h);
  }, []), v = E(
    (h, P, J, _) => {
    },
    []
  ), F = E(() => {
    L((h) => !h);
  }, []);
  return K(() => {
    if (u) {
      const h = [];
      let P = !1;
      u.menuItemInstanceStructureViews.forEach((J) => {
        const _ = je(J);
        _ && (h.push(_), P || (N(_), P = !0, k(!1)));
      }), T(h);
    }
  }, [u, k]), K(() => {
    U(!1);
  }, [U]), /* @__PURE__ */ a(Ze, { backend: ri, children: /* @__PURE__ */ q("div", { className: d.root, children: [
    /* @__PURE__ */ a("div", { className: d.sidebar, children: /* @__PURE__ */ a(
      qe,
      {
        title: u == null ? void 0 : u.name,
        isUsingChildren: !0,
        resizable: !0,
        removePadding: !0,
        removeTopLayoutUnit: !0,
        onUtilitySidebarToggleExpandClick: F,
        collapsedWidth: 64,
        children: /* @__PURE__ */ q("div", { className: d.menuContent, children: [
          (I == null ? void 0 : I.length) > 0 && !A && I.map((h, P) => /* @__PURE__ */ a("div", { className: d.nodeContainer, children: /* @__PURE__ */ a(
            li,
            {
              menuItems: h,
              onSelectNode: m,
              onDropNode: v,
              menuIndex: P,
              selectedNodeId: r == null ? void 0 : r.id,
              selectedNodeParentId: r == null ? void 0 : r.parentId,
              sidebarExpanded: p,
              treeViewMode: C.Classic
            }
          ) }, h.id)),
          A && /* @__PURE__ */ a("div", { className: d.loader, children: /* @__PURE__ */ a(We, { loading: A }) })
        ] }, B)
      }
    ) }),
    /* @__PURE__ */ a("div", { className: d.content, children: ((s = (c = r == null ? void 0 : r.properties) == null ? void 0 : c.page) == null ? void 0 : s.id) && /* @__PURE__ */ a(
      Ge,
      {
        user: f,
        pageData: o,
        pageLoading: z,
        widgetParams: {
          pageId: o == null ? void 0 : o.pageId,
          entityName: (M = (V = (b = r == null ? void 0 : r.properties) == null ? void 0 : b.page) == null ? void 0 : V.entity) == null ? void 0 : M.entityName,
          pbiReportCode: (t = (D = r == null ? void 0 : r.properties) == null ? void 0 : D.page) == null ? void 0 : t.pbiReportCode,
          requiredFieldsMap: (w = (x = r == null ? void 0 : r.properties) == null ? void 0 : x.page) == null ? void 0 : w.requiredFieldMapping,
          udpTagId: (R = (S = r == null ? void 0 : r.properties) == null ? void 0 : S.page) == null ? void 0 : R.udpTagId,
          queryId: (y = (j = r == null ? void 0 : r.properties) == null ? void 0 : j.page) == null ? void 0 : y.queryId,
          inquiryTreeId: (G = (W = r == null ? void 0 : r.properties) == null ? void 0 : W.page) == null ? void 0 : G.inquiryTreeId
        },
        disableMargins: !0,
        fromMenu: !0
      },
      r == null ? void 0 : r.id
    ) })
  ] }) });
};
export {
  xi as MenuPage
};
