import { jsx as u, jsxs as k, Fragment as z } from "react/jsx-runtime";
import Ce, { useCallback as V, useState as O, useMemo as w, useEffect as ce } from "react";
import { f as q, g as J, h as I, F as X, i as Me, j as D, D as Re, k as _e, l as Ne, S as De, a as Se, b as F, L as le, m as Ve, u as Oe, e as ke, n as pe, o as Le, p as Z, q as he, r as ve, s as xe, v as Ue, w as $e } from "./index-Bx-K1R4c.js";
import { EditIcon as Ee, DeleteIcon as qe, AddIcon as je } from "@fluentui/react-icons";
import { TextField as Ge, FormControlLabel as We, makeStyles as be, Typography as ge, Divider as ze } from "@material-ui/core";
import { format as He } from "date-fns";
import { cloneDeep as Qe } from "lodash";
import { useTranslation as Ye } from "react-i18next";
import { useLocation as ye } from "react-router-dom";
import M from "prop-types";
import { DndProvider as Ke } from "react-dnd";
import { HTML5Backend as Je } from "react-dnd-html5-backend";
import { Skeleton as me } from "@material-ui/lab";
import "react-final-form";
import "final-form";
const Xe = {
  headerName: "",
  field: "",
  minWidth: 80,
  autoHeight: !0,
  sortable: !0
}, Ze = (c, t, p = "Actions", d = "actionsRenderer", a = "right") => {
  let m = (c == null ? void 0 : c.reduce((s, n) => (s.push({
    ...Xe,
    headerName: q((n == null ? void 0 : n.name) || ""),
    field: n == null ? void 0 : n.name
  }), s), [])) || [];
  return m.push({
    headerName: d === "actionsRenderer" ? "Actions" : p,
    filter: !1,
    pinned: a,
    width: 150,
    maxWidth: 180,
    cellRenderer: d,
    cellRendererParams: {
      actionList: t
    },
    valueGetter: (s) => s.data,
    suppressMenu: !0,
    sortable: !1,
    cellStyle: { display: "flex", alignItems: "center" }
  }), m;
};
function Fe() {
  return {
    renderInputByFieldType: V(
      (t, p, d, a) => {
        var S;
        const m = [
          J.Int,
          J.Long,
          J.Double
        ];
        t.type === "boolean" && d[I(t.name)] === "" && (d[I(t.name)] = !1);
        const s = (S = t.type) == null ? void 0 : S.toLowerCase();
        let n = m.includes(s);
        const y = /* @__PURE__ */ u(
          X,
          {
            component: Ge,
            id: `${t.name}${p}`,
            name: I(t.name),
            label: q(t.name),
            initialValue: d[I(t.name)] || "",
            type: n && "number",
            fullWidth: !0,
            variant: "outlined",
            size: "small",
            required: !(t != null && t.nullable),
            margin: "dense",
            InputProps: {
              classes: {
                root: a == null ? void 0 : a.input,
                input: a == null ? void 0 : a.formTextInput
              }
            },
            InputLabelProps: {
              classes: {
                root: a == null ? void 0 : a.labelRoot
              }
            },
            disabled: t == null ? void 0 : t.disabled
          }
        ), R = /* @__PURE__ */ u(
          We,
          {
            control: /* @__PURE__ */ u(
              X,
              {
                component: Me,
                type: "checkbox",
                id: `${t.name}${p}`,
                name: I(t.name),
                label: q(t.name),
                initialValue: typeof d[I(t.name)] == "boolean" ? d[I(t.name)] : d[I(t.name)] === "true",
                disabled: t == null ? void 0 : t.disabled,
                classes: { root: a == null ? void 0 : a.switchRoot },
                color: "secondary",
                inputProps: { "aria-label": "Active condition" }
              }
            ),
            label: q(t.name),
            labelPlacement: "start",
            style: { marginLeft: 4 }
          }
        );
        switch (s.toLowerCase()) {
          case D(s, "int"):
          case D(s, "long"):
          case D(s, "double"):
          case D(s, "string"):
          case D(s, "string uuid"):
            return y;
          case D(s, "boolean"):
            return R;
          case D(s, "datetime"):
            return /* @__PURE__ */ u(
              X,
              {
                disabled: t == null ? void 0 : t.disabled,
                component: Re,
                id: `${t.name}${p}`,
                name: I(t.name),
                label: q(t.name),
                initialValue: d[I(t.name)] ? new Date(
                  d[I(t.name)]
                ) : "",
                fullWidth: !0,
                variant: "outlined",
                size: "small",
                required: !(t != null && t.nullable),
                style: { marginTop: 8 }
              }
            );
          default:
            return null;
        }
      },
      []
    )
  };
}
const et = be((c) => ({
  actions: {
    marginTop: c.spacing(2),
    marginBottom: c.spacing(2),
    display: "flex",
    flexDirection: "row"
  },
  title: {
    flexGrow: 1
  },
  subject: {
    marginLeft: c.spacing(1),
    display: "flex",
    flexDirection: "row",
    flexGrow: 1
  },
  switchRoot: {
    marginLeft: c.spacing(1)
  },
  input: {
    height: 34,
    padding: 0
  },
  formTextInput: {
    fontSize: 13
  },
  labelRoot: {
    fontSize: 13
  }
})), fe = (c) => {
  const { tableDescription: t, rowValue: p, closeSideSheet: d, onCreate: a, onUpdate: m } = c, { renderInputByFieldType: s } = Fe(), [n] = O(
    p || {}
  ), y = et();
  return /* @__PURE__ */ k(_e, { onSubmit: async (S) => {
    let f = {
      ...n,
      ...S
    };
    !p ? a && await a(f) : m && await m(f), d && d();
  }, children: [
    /* @__PURE__ */ u("div", { children: t == null ? void 0 : t.map((S, f) => /* @__PURE__ */ k(Ce.Fragment, { children: [
      /* @__PURE__ */ u(ge, { variant: "subtitle2", style: { marginTop: 8 }, children: S.friendlyName }),
      s(
        S,
        f,
        n,
        y
      )
    ] }, `${S.name}-${f}`)) }),
    /* @__PURE__ */ u(Ne, { children: /* @__PURE__ */ u(
      De,
      {
        variant: "contained",
        color: "secondary",
        disablePristine: !1,
        disabled: !1,
        style: { marginTop: 15 },
        children: "Save"
      }
    ) })
  ] });
};
fe.propTypes = {
  /**
   * onClick event for closing sidesheet
   */
  closeSideSheet: M.func,
  /**
   * onClick event for creating
   */
  onCreate: M.func,
  /**
   * onClick event for updating
   */
  onUpdate: M.func
};
const tt = be((c) => ({
  root: {},
  divider: {
    marginTop: c.spacing(2)
  }
})), at = 10, ee = (c) => {
  const {
    tableDescription: t,
    value: p,
    crudTableEditionData: d,
    closeSideSheet: a,
    onCreate: m,
    onUpdate: s,
    pageId: n,
    setSideSheetWidth: y,
    setSideSheetButtonLabel: R,
    setSideSheetOnSubmit: S,
    setSideSheetProps: f
  } = c, L = Se(), _ = tt(), [{ data: T, loading: H }] = F(
    process.env.REACT_APP_TENANTS_API_BASE,
    `page/${n}`,
    {},
    !n,
    !1
  ), j = w(() => {
    const N = [];
    for (let $ = 0; $ < at; $++)
      N.push(
        /* @__PURE__ */ k(z, { children: [
          /* @__PURE__ */ u(me, { variant: "rect", className: _.skeleton }, $),
          /* @__PURE__ */ u(le, { unit: "xxs" })
        ] })
      );
    return N;
  }, [_]), Q = w(() => T ? /* @__PURE__ */ u(Ke, { backend: Je, children: /* @__PURE__ */ u(
    Ve,
    {
      user: L,
      pageData: T,
      widgetParams: {
        pageId: T == null ? void 0 : T.pageId,
        nodeObj: d,
        setSideSheetWidth: y,
        setSideSheetButtonLabel: R,
        setSideSheetOnSubmit: S,
        closeSideSheet: a,
        setSideSheetProps: f,
        onCreate: m,
        onUpdate: s
      },
      disableMargins: !0
    },
    n
  ) }) : /* @__PURE__ */ k(z, { children: [
    /* @__PURE__ */ u(
      fe,
      {
        tableDescription: t,
        rowValue: p,
        closeSideSheet: a,
        onCreate: m,
        onUpdate: s
      }
    ),
    /* @__PURE__ */ u("div", { className: _.divider, children: /* @__PURE__ */ u(ze, {}) })
  ] }), [
    T,
    L,
    n,
    d,
    y,
    R,
    S,
    f,
    a,
    m,
    s,
    _,
    t,
    p
  ]);
  return /* @__PURE__ */ u("div", { children: H ? /* @__PURE__ */ k(z, { children: [
    j.map((N) => N),
    /* @__PURE__ */ u(le, { unit: "md" }),
    /* @__PURE__ */ u(me, { variant: "rect", className: _.skeletonButton })
  ] }) : Q });
};
ee.propTypes = {
  /**
   * Description of the table
   */
  tableDescription: M.array,
  /**
   * Entity data
   */
  crudTableEditionData: M.array,
  /**
   * onClick event for closing sidesheet
   */
  closeSideSheet: M.func,
  /**
   * onClick event for creating
   */
  onCreate: M.func,
  /**
   * onClick event for updating
   */
  onUpdate: M.func
};
const nt = () => {
  const { search: c } = ye();
  return w(() => new URLSearchParams(c), [c]);
}, ft = (c) => {
  var ie, ue, de;
  const { ...t } = c, p = nt(), d = ye(), { value: a, promotedEntity: m } = d.state || {}, s = (ie = d == null ? void 0 : d.pathname) == null ? void 0 : ie.split("/"), n = a ? a == null ? void 0 : a.id : s ? s[s.length - 1] : null, y = Se(), R = Oe(), [S, f] = O(!1), [L, _] = O(600), [T, H] = O(""), [j, Q] = O({}), [N, $] = O(
    () => () => console.warn("onSubmit not set")
  ), [e, Ae] = O(m), { t: h } = Ye(), { handleErrorSnackbar: v, handleSuccessSnackbar: x } = ke(), Y = V(() => {
    f(!1);
  }, []), B = w(() => e ? e.entityName || "" : p.has("entityName") === !0 ? p.get("entityName") : "", [e, p]), te = w(() => {
    var o;
    return (o = e == null ? void 0 : e.unityBaseCreateMethod) == null ? void 0 : o.pageId;
  }, [e]), [{ data: G }] = F(
    process.env.REACT_APP_INTEGRATION_API_BASE,
    `tenantProductApiCatalogBase/tenant/${y == null ? void 0 : y.currentTenantId}/product/${process.env.REACT_APP_UNITY_PRODUCT_ID}`,
    {},
    !y || !!m,
    !1
  ), [{ data: K }] = F(
    process.env.REACT_APP_INTEGRATION_API_BASE,
    `apicatalog/${G == null ? void 0 : G.apiCatalogId}/promotedMethodEntities/${B}/product/${process.env.REACT_APP_UNITY_PRODUCT_ID}`,
    {},
    !G || !y || !B,
    !1
  ), [{ data: b, loading: Ie }, C] = pe(
    process.env.REACT_APP_INTEGRATION_API_BASE,
    `apimethod/executeQueryWithParameters/${(ue = e == null ? void 0 : e.unityBaseGetDataMethod) == null ? void 0 : ue.apiMethodId}`,
    {
      method: "post"
    }
  ), [
    { data: l },
    ae
  ] = pe(
    process.env.REACT_APP_INTEGRATION_API_BASE,
    `apimethod/executeQueryWithParameters/${(de = e == null ? void 0 : e.unityBaseDescribeMethod) == null ? void 0 : de.apiMethodId}`,
    {
      method: "post"
    }
  ), W = V(
    (o) => {
      if (!l)
        return [];
      const g = [];
      return l.forEach((r) => {
        const i = typeof o[r.name] == "boolean" || o[r.name];
        if (r.name || i)
          switch (B == null ? void 0 : B.toLowerCase()) {
            case Le.Udp_Lookup.toLowerCase():
              g.push({
                lookupColumnId: r.id,
                value: o[r.name]
              });
              break;
          }
      }), g;
    },
    [l, B]
  ), ne = V(
    async (o) => {
      if (e != null && e.unityBaseVirtualCreateMethod) {
        const r = { requestBody: W(o), id: n }, i = await Z(
          { data: r },
          e.unityBaseVirtualCreateMethod.apiMethodId
        ).catch((A) => {
          v(A.message);
        });
        (i == null ? void 0 : i.status) === 200 && (x(h("Row has been created")), C({ data: { id: n } }));
      }
    },
    [
      e,
      h,
      C,
      v,
      x,
      n,
      W
    ]
  ), oe = V(
    async (o) => {
      if (e != null && e.unityBaseVirtualUpdateMethod) {
        const g = [n, o.udpVirtualRowId], r = he(
          e.unityBaseVirtualUpdateMethod.pathParameters,
          g
        ), i = W(o);
        let A = { requestBody: i };
        Array.isArray(r) ? r.forEach((U) => {
          A[Object.keys(U)[0]] = U[Object.keys(U)[0]];
        }) : A = { ...r, requestBody: i };
        const P = await Z(
          { data: A },
          e.unityBaseVirtualUpdateMethod.apiMethodId
        ).catch((U) => {
          v(U.message);
        });
        (P == null ? void 0 : P.status) === 200 && (x(h("Row has been updated")), C({ data: { id: n } }));
      }
    },
    [
      e,
      h,
      C,
      v,
      x,
      n,
      W
    ]
  ), re = V(
    async (o) => {
      if (e != null && e.unityBaseVirtualDeleteMethod) {
        const g = [n, o.udpVirtualRowId], r = he(
          e == null ? void 0 : e.unityBaseVirtualDeleteMethod.pathParameters,
          g
        );
        let i = {};
        Array.isArray(r) ? r.forEach((P) => {
          i[Object.keys(P)[0]] = P[Object.keys(P)[0]];
        }) : i = { ...r };
        const A = await Z(
          { data: i },
          e.unityBaseVirtualDeleteMethod.apiMethodId
        ).catch((P) => {
          v(P.message);
        });
        (A == null ? void 0 : A.status) === 200 && (x(h("Row has been deleted")), C({ data: { id: n } }));
      }
    },
    [
      e,
      h,
      C,
      v,
      x,
      n
    ]
  ), se = w(() => {
    var o;
    if (e)
      return [
        {
          id: 1,
          // Must be unique
          title: e != null && e.unityBaseVirtualUpdateMethod ? h("Edit") : h("Edit Method Not Accessible"),
          icon: Ee,
          onClick: null,
          opens: "sideSheet",
          view: {
            component: ee,
            properties: {
              tableDescription: l,
              onUpdate: oe,
              valuePropName: "value",
              closeSideSheet: null,
              closeSideSheetPropName: "closeSideSheet",
              pageId: (o = e == null ? void 0 : e.unityBaseVirtualUpdateMethod) == null ? void 0 : o.pageId,
              isNewEntry: !1
            }
          },
          disabled: !(e != null && e.unityBaseVirtualUpdateMethod)
        },
        {
          id: 2,
          // Must be unique
          title: e != null && e.unityBaseVirtualDeleteMethod ? h("Delete") : h("Delete Method Not Accessible"),
          icon: qe,
          onClick: null,
          opens: "dialog",
          view: {
            component: null,
            properties: {
              title: h("Delete"),
              message: h("Are you sure you want to delete this row?"),
              labelOne: h("Cancel"),
              actionTwo: re,
              labelTwo: h("Confirm")
            }
          },
          disabled: !(e != null && e.unityBaseVirtualDeleteMethod)
        }
      ];
  }, [e, h, oe, re, l]), E = w(() => l != null && l.length ? Ze(l, se) : [], [se, l]), Pe = w(() => E == null ? void 0 : E.map((o) => ({
    groupItem: o.field,
    label: o.headerName,
    value: o.field
  })), [E]);
  ce(() => {
    K && Ae(K);
  }, [K]), ce(() => {
    var o, g;
    if (n) {
      const r = { id: n };
      (o = e == null ? void 0 : e.unityBaseGetDataMethod) != null && o.apiMethodId && C({ data: r }), (g = e == null ? void 0 : e.unityBaseDescribeMethod) != null && g.apiMethodId && ae({ data: r });
    }
  }, [e, C, n, ae]);
  const Te = /* @__PURE__ */ k($e, { onClick: () => f && f(!0), children: [
    /* @__PURE__ */ u(ge, { style: { marginRight: 5 }, children: "Add" }),
    /* @__PURE__ */ u(je, {})
  ] }), we = w(
    () => /* @__PURE__ */ u(
      ve,
      {
        open: S,
        onClose: Y,
        title: `Add new ${B}`,
        width: L,
        buttonLabel: T,
        onSubmit: N,
        ...j,
        children: /* @__PURE__ */ u(
          ee,
          {
            onCreate: ne,
            closeSideSheet: Y,
            pageId: te,
            setSideSheetWidth: _,
            setSideSheetButtonLabel: H,
            setSideSheetOnSubmit: $,
            setSideSheetProps: Q,
            tableDescription: l
          }
        )
      }
    ),
    [
      S,
      Y,
      B,
      L,
      T,
      N,
      ne,
      te,
      j,
      l
    ]
  ), Be = V(() => {
    if (b != null && b.data && l) {
      let o = Qe(b == null ? void 0 : b.data);
      const g = l == null ? void 0 : l.reduce((r, i) => ((i == null ? void 0 : i.type) === "datetime" && r.push(i == null ? void 0 : i.name), r), []);
      return g.length && o.forEach((r) => {
        Object.keys(r).forEach((i) => {
          if (g.find((A) => A === i)) {
            if (r[i] === null) return;
            r[i] = He(new Date(r[i]), "yyyy/MM/dd kk:mm:ss");
          }
        });
      }), o;
    }
    return [];
  }, [b, l]);
  return /* @__PURE__ */ k(z, { children: [
    /* @__PURE__ */ u(
      xe,
      {
        title: (a == null ? void 0 : a.name) || (b == null ? void 0 : b.name),
        data: b ? Be(b == null ? void 0 : b.data) : [],
        columnDefs: E,
        groupingData: Pe,
        primaryActionButton: Te,
        frameworkComponents: { actionsRenderer: Ue },
        height: `calc(100vh - ${R ? "139px" : "114px"})`,
        disableRowSelection: !0,
        loading: Ie,
        ...t
      }
    ),
    we
  ] });
};
export {
  ft as VirtualBrowser,
  ft as default
};
