import { jsx as d, jsxs as B } from "react/jsx-runtime";
import { useState as h, useCallback as w, useEffect as g } from "react";
import { useHistory as X, useLocation as L } from "react-router-dom";
import { u as q, A as J, a as K, b as A, c as Q, t as Z, U as ee, W as ae, T as te, N as oe, d as ne } from "./index-Bx-K1R4c.js";
import { makeStyles as se } from "@material-ui/core";
import { DndProvider as re } from "react-dnd";
import { HTML5Backend as le } from "react-dnd-html5-backend";
const ie = () => {
  const r = X(), t = L();
  return (u) => {
    const m = new URLSearchParams(t.search);
    Object.keys(u).forEach((n) => {
      u[n] !== null ? m.set(n, u[n]) : m.delete(n);
    }), r.push({
      pathname: t.pathname,
      search: m.toString()
    });
  };
}, de = se((r) => ({
  root: {
    flex: 1,
    minHeight: ({ appRibbonSpace: t }) => `calc(100vh - ${t + 56}px)`,
    display: "grid",
    gridTemplateAreas: ["sidebar content"].map((t) => `"${t}"`).join(" "),
    gridTemplateColumns: "auto 1fr",
    gridTemplateRows: "auto 1fr"
  },
  sidebar: {
    gridArea: "sidebar",
    marginRight: r.spacing(1)
  },
  content: {
    gridArea: "content",
    display: "flex",
    flexDirection: "column",
    position: "relative",
    zIndex: 1,
    height: ({ appRibbonSpace: t }) => `calc(100vh - ${t + 56}px)`,
    overflowY: "auto"
  },
  menuContent: {
    marginTop: r.spacing(1),
    height: ({ appRibbonSpace: t }) => `calc(100vh - ${t + 116}px)`,
    overflowX: "hidden"
  },
  loader: {
    marginRight: r.spacing(1),
    marginLeft: r.spacing(1)
  },
  loadingContent: {
    flex: 1,
    display: "flex",
    flexDirection: "column",
    alignItems: "center",
    justifyContent: "center"
  }
})), Ie = (r) => {
  const { playId: t, taskId: C, autoCollapseNav: u = !0 } = r, m = q(), n = de({
    ...r,
    appRibbonSpace: m ? J : 0
  }), k = L(), E = ie(), o = K(), [f, M] = h([]), [l, I] = h(null), [D, $] = h(!0), [b, v] = h(!1), [c, j] = h(!1), P = k.state;
  let H = k.search, S = new URLSearchParams(H);
  const O = k.pathname.replace("/workflowtask/", ""), _ = t || O || (P ? P.playId : S.has("playId") === !0 ? S.get("playId") : ""), y = C || (P ? P.taskId : S.has("taskId") === !0 ? S.get("taskId") : ""), [{ data: T, loading: N }, R] = A(
    process.env.REACT_APP_BUILDER_API_BASE,
    `workflow/play/${_}`,
    {},
    !_,
    !1
  ), [{ data: Y }] = A(
    process.env.REACT_APP_SECURITY_API_BASE,
    `users?tenantId=${(o == null ? void 0 : o.currentTenantId) || ""}`,
    {},
    !(o != null && o.currentTenantId)
  ), [{ data: z }] = A(
    process.env.REACT_APP_TENANTS_API_BASE,
    `groups?tenantId=${(o == null ? void 0 : o.currentTenantId) || ""}&productId=${process.env.REACT_APP_UNITY_PRODUCT_ID}`,
    {},
    !(o != null && o.currentTenantId)
  ), { setSubHeaderActionHasChildren: U, setNavigationExpanded: W } = Q(), x = w(async () => {
    v(!0), await R(), v(!1);
  }, [R]), F = w(
    async (e, a) => {
      var s;
      e.isSelectable && (I(e), await x(), (s = e == null ? void 0 : e.properties) != null && s.playSceneId && E({ taskId: e.properties.playSceneId }));
    },
    [E, x]
  ), V = w(
    (e, a, s, i) => {
    },
    []
  ), G = w(() => {
    $((e) => !e);
  }, []);
  return g(() => {
    T && j(T);
  }, [T]), g(() => {
    c && I((e) => {
      var a, s;
      if (e) {
        const i = (s = (a = c.workflowPlayNode) == null ? void 0 : a.children) == null ? void 0 : s.find(
          (p) => p.id === e.id
        );
        if (i) {
          const p = { ...e };
          return p.properties.state = i.state, p;
        } else
          return e;
      }
    });
  }, [c]), g(() => {
    if (c) {
      const e = [], a = Z(c.workflowPlayNode);
      a && e.push(a), M(e);
    }
  }, [c]), g(() => {
    var e;
    if (!l) {
      const a = f[0];
      if (a) {
        if (y) {
          const s = a.children.find(
            (i) => {
              var p;
              return ((p = i == null ? void 0 : i.properties) == null ? void 0 : p.playSceneId) === y;
            }
          );
          I(s || a.children[0] || null);
        } else {
          const s = (e = a == null ? void 0 : a.children) == null ? void 0 : e.find(
            (i) => i.isSelectable
          );
          I(s || null);
        }
        u && W(!1);
      }
    }
  }, [
    y,
    f,
    l,
    W,
    u
  ]), g(() => {
    U(!1);
  }, [U]), /* @__PURE__ */ d(re, { backend: le, children: /* @__PURE__ */ B("div", { className: n.root, children: [
    /* @__PURE__ */ d("div", { className: n.sidebar, children: /* @__PURE__ */ d(
      ee,
      {
        title: "Workflow",
        isUsingChildren: !0,
        resizable: !0,
        removePadding: !0,
        removeTopLayoutUnit: !0,
        onUtilitySidebarToggleExpandClick: G,
        collapsedWidth: 64,
        children: /* @__PURE__ */ B("div", { className: n.menuContent, children: [
          (f == null ? void 0 : f.length) > 0 && (!N || b) && f.map((e, a) => /* @__PURE__ */ d("div", { className: n.nodeContainer, children: /* @__PURE__ */ d(
            ae,
            {
              menuItems: e,
              onSelectNode: F,
              onDropNode: V,
              menuIndex: a,
              selectedNodeId: l == null ? void 0 : l.id,
              selectedNodeParentId: l == null ? void 0 : l.parentId,
              sidebarExpanded: D,
              treeViewMode: te.Classic
            }
          ) }, e.id)),
          N && !b && /* @__PURE__ */ d("div", { className: n.loader, children: /* @__PURE__ */ d(oe, { loading: N }) })
        ] }, t)
      }
    ) }),
    /* @__PURE__ */ d("div", { className: n.content, children: /* @__PURE__ */ d(
      ne,
      {
        selectedNode: l,
        workflow: c,
        reloadWorkflow: x,
        users: Y,
        groups: z
      }
    ) })
  ] }) });
};
export {
  Ie as WorkflowContainer
};
